/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VUniqueNameRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VUniqueName extends TableImpl<VUniqueNameRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_unique_name</code>
     */
    public static final VUniqueName V_UNIQUE_NAME = new VUniqueName();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VUniqueNameRecord> getRecordType() {
        return VUniqueNameRecord.class;
    }

    /**
     * The column <code>common_dd.v_unique_name.key_element</code>.
     */
    public final TableField<VUniqueNameRecord, Integer> KEY_ELEMENT = createField(DSL.name("key_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_unique_name.unique_name</code>.
     */
    public final TableField<VUniqueNameRecord, String> UNIQUE_NAME = createField(DSL.name("unique_name"), SQLDataType.CLOB, this, "");

    private VUniqueName(Name alias, Table<VUniqueNameRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VUniqueName(Name alias, Table<VUniqueNameRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_unique_name" as  SELECT h.key_element,
         ((COALESCE(s.unique_name_prefix, g.unique_name_prefix, p.unique_name_prefix) || '.'::text) || lower(h.short_name)) AS unique_name
        FROM ((((common_dd.t_core_element_hierarchy h
          LEFT JOIN common_dd.v_core_study v ON ((v.key_element = h.key_element)))
          LEFT JOIN common_dd.t_core_study s ON ((s.fk_element = v.study_element)))
          LEFT JOIN common_dd.t_core_studygroup g ON ((g.fk_element = h.key_element)))
          LEFT JOIN common_dd.t_core_studygroup p ON ((p.fk_element = h.key_parent_element)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_unique_name</code> table reference
     */
    public VUniqueName(String alias) {
        this(DSL.name(alias), V_UNIQUE_NAME);
    }

    /**
     * Create an aliased <code>common_dd.v_unique_name</code> table reference
     */
    public VUniqueName(Name alias) {
        this(alias, V_UNIQUE_NAME);
    }

    /**
     * Create a <code>common_dd.v_unique_name</code> table reference
     */
    public VUniqueName() {
        this(DSL.name("v_unique_name"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VUniqueName as(String alias) {
        return new VUniqueName(DSL.name(alias), this);
    }

    @Override
    public VUniqueName as(Name alias) {
        return new VUniqueName(alias, this);
    }

    @Override
    public VUniqueName as(Table<?> alias) {
        return new VUniqueName(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VUniqueName rename(String name) {
        return new VUniqueName(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VUniqueName rename(Name name) {
        return new VUniqueName(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VUniqueName rename(Table<?> name) {
        return new VUniqueName(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VUniqueName where(Condition condition) {
        return new VUniqueName(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VUniqueName where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VUniqueName where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VUniqueName where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VUniqueName where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VUniqueName where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VUniqueName where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VUniqueName where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VUniqueName whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VUniqueName whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
